Draft SelectPlane: Difference between revisions

From FreeCAD Documentation
mNo edit summary
No edit summary
Line 44: Line 44:
<!--T:15-->
<!--T:15-->
# There are several ways to invoke the command:
# There are several ways to invoke the command:
#* Press the [[Image:Draft_tray_button_plane.png]] {{MenuCommand|Select Plane}} button in the [[Draft_Tray|Draft Tray]].
#* Press the [[Image:Draft_tray_button_plane.png]] {{MenuCommand|Select Plane}} button in the [[Draft_Tray|Draft Tray]]. Depending on the current working plane this button can look different.
#* Select the {{MenuCommand|Utilities → [[Image:Draft_SelectPlane.svg|16px]] Select Plane}} option from the menu.
#* Select the {{MenuCommand|Utilities → [[Image:Draft_SelectPlane.svg|16px]] Select Plane}} option from the menu.
#* Use the keyboard shortcut: {{KEY|W}} then {{KEY|P}}.
#* Use the keyboard shortcut: {{KEY|W}} then {{KEY|P}}.

Revision as of 10:32, 26 July 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft SelectPlane

Menu location
Utilities → Select Plane
Workbenches
Draft, Arch
Default shortcut
W P
Introduced in version
-
See also
Draft WorkingPlaneProxy, Draft ToggleGrid

Description

The Draft Workbench features a working plane system. A plane in the 3D view indicates where a Draft shape will be built. There are several methods to define the working plane:

  • From a selected face.
  • From three selected vertices.
  • From the current view.
  • From a preset: top, front, or side.
  • None, in which case the working plane is adapted automatically to the current view when you start a command, or to a face if you start drawing on an existing face.

Shapes created on different working planes

No selection

Usage

  1. There are several ways to invoke the command:
    • Press the Select Plane button in the Draft Tray. Depending on the current working plane this button can look different.
    • Select the Utilities → Select Plane option from the menu.
    • Use the keyboard shortcut: W then P.
  2. The Working plane setup task panel opens. See Options for more information.
  3. Pressing any of the buttons will finish the command.
  4. The button in the Draft Tray is updated.

Options

  • Press the Top (XY) button to align the working plane with the XY plane of the global coordinate system.
  • Press the Front (XZ) button to align the working plane with the XZ plane of the global coordinate system.
  • Press the Side (YZ) button to align the working plane with the YZ plane of the global coordinate system.
  • Press the Align to view button to align the working plane with the current 3D view. If the Center plane on view checkbox is unchecked the working plane origin will match the origin of the global coordinate system, else it will match the center of the current 3D view.
  • Press the Automatic button to automatically align the working plane with the current 3D view whenever a Draft command requiring point input is started. This is equivalent to pressing the Align to view button before using the command.
  • The Offset defines the perpendicular distance between the calculated plane and the actual working plane.
  • Check the Center plane on view checkbox to put the origin of the working plane in the center of to the current 3D view. This option really only makes sense if the Align to view button is used.
  • Select a vertex in the 3D view and press the Move working plane button to move the working plane so that its origin matches the position of the selected vertex.
  • The Grid spacing defines the distance between grid lines.
  • The Main line every value determines where main grid lines are drawn. Main grid lines are slightly thicker than normal grid lines. For example if the grid spacing is 0.5 m and there is a main line every 10 lines, such a line will occur every 5 m.
  • The Grid extension value determines the number of grid lines in the X and Y direction of the grid.
  • The Snapping radius is the distance at which Draft Snap Grid detects the intersections of grid lines.
  • Press the Center view button to use the origin of the current working plane as the center the 3D view.
  • Press the Previous button to reset the working plane to its previous position.
  • Press Esc or the Close button to abort the command.

Pre-selection

Usage

  1. Select a face of an existing object in the 3D view, or hold Ctrl and select three vertices of any object. introduced in version 0.17
  2. Press the SelectPlane button, or right click and select Utilities → SelectPlane.

The plane will be created aligned to the face of the object, or to the plane defined by the three vertices.

Post-selection

Usage

Notes

  • It can be useful to align the 3D view with the selected Draft working plane. For example after switching the working plane to Front you may want to switch to the Front view as well.
  • The grid can be toggled with the Draft ToggleGrid command.
  • Draft WorkingPlaneProxies can be used to quickly switch between working planes.

Preferences

See also: Preferences Editor and Draft Preferences.

  • The grid settings in the task panel as well as several other grid settings are available as preferences: Edit → Preferences... → Draft → Grid and snapping → Grid.
  • The Snapping radius can also be changed on-the-fly (see Draft Snap) or by changing: Tools → Edit parameters... → BaseApp → Preferences → Mod → Draft → snapRange.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

If the Draft Workbench is active the FreeCAD application object has a DraftWorkingPlane property which stores the current Draft working plane. You can access this property and apply transformations to it:

# This code only works if the Draft Workbench is active!

import FreeCAD as App
import FreeCADGui as Gui

doc = App.newDocument()

workplane = App.DraftWorkingPlane

v1 = App.Vector(0, 0, 0)
v2 = App.Vector(1, 1, 1).normalize()

workplane.alignToPointAndAxis(v1, v2, 17)
Gui.Snapper.toggleGrid()
Gui.Snapper.toggleGrid()

It is also possible to create planes independently of the Draft working plane. This can be useful for calculations and projections:

import WorkingPlane

my_plane = WorkingPlane.plane()

v1 = App.Vector(0, 0, 0)
v2 = App.Vector(1, 1, 1).normalize()
my_plane.alignToPointAndAxis(v1, v2, 17)

projection = my_plane.projectPoint(App.Vector(10, 15, 2))
print(projection)